#include <wx/wx.h>
#include "constants.h"
#include "uthread.h"
#include "filetree.h"

UThread::UThread(UFiletree *oNewTree) : wxThread()
{
	iInt = 0;
	this->oTree = oNewTree;
}

void UThread::checkChanges()
{
	// Make sure something is selected.
	if (!oTree->somethingSelected())
	{
		wxMutexGuiEnter();
		oTree->selectTreeItem(oTree->GetRootItem());
		wxMutexGuiLeave();
	}
	
	wxTreeItemId iRoot = oTree->GetRootItem();
	wxTreeItemId iSelected;
	wxString sDir;
	std::vector<wxTreeItemId> iReload;
	wxMutexGuiEnter();
	sDir = oTree->getFullpath(iRoot);
	wxMutexGuiLeave();
	if (oTree->oTimeMonitor.checkTime((char *)sDir.c_str()))
	{
		iReload.insert(iReload.begin(), iRoot);
	}
	wxTreeItemId iCurrent = iRoot;
	while (iCurrent = oTree->getNextID(iCurrent))
	{
		wxMutexGuiEnter();
		sDir = oTree->getFullpath(iCurrent);
		wxMutexGuiLeave();
		if (oTree->oTimeMonitor.checkTime((char *)sDir.c_str()))
		{
			iReload.insert(iReload.begin(), iCurrent);
		}
	}
	if (iReload.size() > 0)
	{
		for (unsigned int i = 0; i < iReload.size(); i++)
		{
			wxMutexGuiEnter();
			oTree->ReloadDir(iReload[i], true);
			wxMutexGuiLeave();
		}
	}
}

void *UThread::Entry()
{
	while (true)
	{
		wxThread::Sleep(100);
		this->checkChanges();
	}
	
	return NULL;
}

